## dde-dialog 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.0)
project(dialog VERSION 0.1.0 LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include(GNUInstallDirs)

set(DATA_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/dde-dialog" CACHE PATH "Data directory")

find_package(PkgConfig)

find_package(Qt6 REQUIRED COMPONENTS Core Quick DBus)
find_package(Dtk6 REQUIRED COMPONENTS Core Gui)
find_package(yaml-cpp REQUIRED)
find_package(fmt REQUIRED)

qt_standard_project_setup()

qt_policy(SET QTP0001 NEW)

pkg_check_modules(libsystemd REQUIRED IMPORTED_TARGET libsystemd)

pkg_search_module(systemd REQUIRED systemd)
pkg_get_variable(SYSUSERS_DIR systemd sysusers_dir)
pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemd_user_unit_dir)
pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemd_system_unit_dir)

pkg_search_module(DBUS REQUIRED dbus-1)
pkg_get_variable(DBUS_DATA_DIR dbus-1 datadir)
if(DBUS_DATA_DIR)
    set(DBUS_DATA_DIR "${DBUS_DATA_DIR}/dbus-1")
else()
    set(DBUS_DATA_DIR "${CMAKE_INSTALL_DATADIR}/dbus-1")
endif()

message(CMAKE_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

qt_generate_dbus_interface(src/daemon/DialogAdaptor.h org.deepin.dde.dialog1.xml
    OPTIONS
        -a
        -t "ActionType=i"
)
qt_generate_dbus_interface(src/agent/AgentAdaptor.h org.deepin.dde.dialog1.agent.xml
    OPTIONS
        -a
        -t "Schema=(sssssa{sv})"
)
add_custom_target(dialog_xml ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.dialog1.xml
    COMMENT "Helper target for XML stuff."
)
add_custom_target(agent_xml ALL
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.dialog1.agent.xml
    COMMENT "Helper target for XML stuff."
)

add_subdirectory(src)

install(DIRECTORY DESTINATION ${DATA_DIR})

install(
    FILES misc/example/example.yaml 
    DESTINATION ${DATA_DIR}
)

install(
    FILES misc/sysusers.d/dde-dialog.conf
    DESTINATION ${SYSUSERS_DIR}
)

install(
    FILES misc/systemd/system/dde-dialog.service
    DESTINATION ${SYSTEMD_SYSTEM_UNIT_DIR}
)

install(
    FILES misc/systemd/user/dde-dialog-agent.service
    DESTINATION ${SYSTEMD_USER_UNIT_DIR}
)

install(
    FILES misc/dbus/conf.d/org.deepin.dde.dialog1.conf
    DESTINATION ${DBUS_DATA_DIR}/system.d
)

install(
    FILES misc/dbus/system-services/org.deepin.dde.dialog1.service
    DESTINATION ${DBUS_DATA_DIR}/system-services
)

=== src/CMakeLists.txt ===
include_directories(common)

add_subdirectory(daemon)
add_subdirectory(agent)

=== src/agent/CMakeLists.txt ===
set(BIN_NAME dialog-agent)

set(DIALOG_AGENT_SRCS
    main.cpp
    Agent.h
    Agent.cpp
    AgentAdaptor.h
    AgentAdaptor.cpp
    DialogModel.h
    DialogModel.cpp
    DialogInstance.h
    DialogInstance.cpp
    ../common/DBusTypes.h
    ../common/DBusTypes.cpp
)

set_source_files_properties(${CMAKE_BINARY_DIR}/org.deepin.dde.dialog1.xml PROPERTIES
    INCLUDE DBusTypes.h
)
qt_add_dbus_interface(DIALOG_AGENT_SRCS ${CMAKE_BINARY_DIR}/org.deepin.dde.dialog1.xml DialogInterface)

qt_add_executable(${BIN_NAME})

qt_add_qml_module(${BIN_NAME}
    URI agent
    VERSION 1.0
    SOURCES
        ${DIALOG_AGENT_SRCS}
    QML_FILES
        Main.qml
)

add_dependencies(${BIN_NAME} dialog_xml)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt6::Quick
    Qt6::DBus
    Dtk6::Core
    Dtk6::Gui
    fmt
)

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/daemon/CMakeLists.txt ===
set(BIN_NAME dialog-daemon)

set(DIALOG_DAEMON_SRCS
    main.cpp
    DialogAdaptor.h
    DialogAdaptor.cpp
    ../common/DBusTypes.h
    ../common/DBusTypes.cpp
)

qt_add_executable(${BIN_NAME})

set_source_files_properties(org.freedesktop.login1.Manager.xml PROPERTIES
    INCLUDE DBusTypes.h
)
set_source_files_properties(org.freedesktop.login1.Session.xml PROPERTIES
    INCLUDE DBusTypes.h
)
set_source_files_properties(${CMAKE_BINARY_DIR}/org.deepin.dde.dialog1.agent.xml PROPERTIES
    INCLUDE DBusTypes.h
)
qt_add_dbus_interface(DIALOG_DAEMON_SRCS org.freedesktop.login1.Manager.xml Login1ManagerInterface)
qt_add_dbus_interface(DIALOG_DAEMON_SRCS org.freedesktop.login1.Session.xml Login1SessionInterface)
qt_add_dbus_interface(DIALOG_DAEMON_SRCS ${CMAKE_BINARY_DIR}/org.deepin.dde.dialog1.agent.xml AgentInterface)

add_dependencies(${BIN_NAME} agent_xml)

target_sources(${BIN_NAME} PRIVATE
    ${DIALOG_DAEMON_SRCS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt6::Core
    Qt6::DBus
    PkgConfig::libsystemd
    yaml-cpp
    fmt
)

install(TARGETS ${BIN_NAME}
    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/dde-dialog
)

configure_file(config.h.in config.h)

=== debian/changelog ===
dde-dialog (1.0.1) UNRELEASED; urgency=medium

  * refactor: 调整control.

 -- echengqi <echengqi@uniontech.org>  Fri, 11 Jan 2025 13:40:36 +0800

dde-dialog (1.0.0) UNRELEASED; urgency=medium

  * Initial release.

 -- unknown <quezhiyong@deepin.org>  Fri, 11 Oct 2024 15:40:36 +0800

=== debian/control ===
Source: dde-dialog
Section: misc
Priority: optional
Maintainer: zsien <quezhiyong@deepin.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libfmt-dev,
 libsystemd-dev,
 libyaml-cpp-dev,
 pkg-config,
 qt6-base-dev,
 qt6-declarative-dev,
 libdtk6core-dev,
 libdtk6gui-dev,
 libdbus-1-dev,
 systemd-dev,
Standards-Version: 4.7.0
Homepage: <https://github.com/linuxdeepin/dde-dialog>
#Vcs-Browser: https://salsa.debian.org/debian/dde-dialog
#Vcs-Git: https://salsa.debian.org/debian/dde-dialog.git

Package: dde-dialog
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: <insert up to 60 chars description>
 <Insert long description, indented with spaces.>

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_installsystemd:
	dh_installsystemd -r

execute_after_dh_installinit:
	dh_installsysusers
